#define _ijps 0
#define _CRT_SECURE_NO_DEPRECATE
#pragma comment(linker, "/STACK:667772160")
#include <iostream>
#include <cmath>
#include <vector>
#include <time.h>
#include <map>
#include <set>
#include <deque>
#include <cstdio>
#include <cstdlib>
#include <unordered_map>
#include <bitset>
#include <algorithm>
#include <string>
#include <fstream>
#include <assert.h>
#include <list>
#include <cstring>
using namespace std;

#define name "mirror"
typedef unsigned long long ull;
typedef long long ll;
#define mk make_pair
#define forn(i, n) for(ll i = 0; i < (ll)n; i++)
#define fornn(i, q, n) for(ll i = (ll)q; i < (ll)n; i++)
#define times clock() * 1.0 / CLOCKS_PER_SEC

struct __isoff{
	__isoff(){
		if (_ijps)
			freopen("input.txt", "r", stdin), freopen("output.txt", "w", stdout);//, reopen("test.txt", "w", stderr);
		else freopen(name".in", "r", stdin), freopen(name".out", "w", stdout);
		//ios_base::sync_with_stdio(0);
		//srand(time(0));
		srand('C' + 'T' + 'A' + 'C' + 'Y' + 'M' + 'B' + 'A');
	}
	~__isoff(){
		//if(_ijps) cout<<times<<'\n';
	}
} __osafwf;
const ull p1 = 131;
const ull p2 = 129;
const double eps = 1e-7;
const double pi = acos(-1.0);

const int infi = 1e9 + 7;
const ll inf = 1e18 + 7;
const ll dd = 2e5 + 7;
const ll mod = 1e9 + 7;

vector<pair<double, double> > T;
#define x0 asdasd
#define y0 asdsghhtdg
double x0, y0;
vector<double> R;
int n;

double vec(pair<double, double> a, pair<double, double> b) {
	return a.first * b.second - a.second * b.first;
}

double sca(pair<double, double> a, pair<double, double> b) { 
	return a.first * b.first + a.second * b.second; 
}
pair<double, double> rec(pair<double, double> p1, pair<double, double> A, pair<double, double> p2, pair<double, double> B){
	if (abs(vec(A, B)) < eps){
		return p1;
	}
	double l = vec(mk(p2.first - p1.first, p2.second - p1.second), B) / vec(A, B);
	pair<double, double> res = mk(p1.first + A.first * l, p1.second + A.second * l);
	return res;
}

int main() {
	cin >> n;
	T.resize(n);
	R.resize(2 * n + 5);
	forn(i, n){
	    scanf("%lf%lf", &T[i].first, &T[i].second);
	}
	cin >> x0 >> y0;
	forn(i, 2 * n){
		R[i + 1] = R[i] + vec(T[i % n], T[(i + 1) % n]);
	}
	forn(i, n){
		double Res = 0;
		{
			int s = i;
			pair<double, double> A, B, N;
			A = T[s];
			B = T[(s + 1) % n];
			N = mk(A.second - B.second, B.first - A.first);
			{
				double l = hypot(N.first, N.second);
				N.first /= l;
				N.second /= l;
			}
			pair<double, double> Ac, Bc;
			Ac = mk(A.first - x0, A.second - y0);
			Ac = mk(Ac.first - N.first * sca(N, Ac) * 2, Ac.second - N.second * sca(N, Ac) * 2);
			Bc = mk(B.first - x0, B.second - y0);
			Bc = mk(Bc.first - N.first * sca(N, Bc) * 2, Bc.second - N.second * sca(N, Bc) * 2);
			int l = 0;
			int r = n - 1;
			{
				while (l < r){
					int f = (l + r + 1) / 2;
					pair<double, double> S = T[(n + s - f) % n];
					if (vec(Ac, mk(S.first - A.first, S.second - A.second)) < 0){
						r = f - 1;
					}
					else{
						l = f;
					}
				}
			}
			pair<double, double> df = rec(T[(n + s - l) % n], mk(T[(n + s - l - 1) % n].first - T[(n + s - l) % n].first, T[(n + s - l - 1) % n].second - T[(n + s - l) % n].second), A, Ac);
			Res += R[n] - (R[s + n] - R[s + n - l] + vec(A, df) + vec(df, T[(n + s - l) % n]));
			{
				l = 0, r = n - 1;
				while (l < r){
					int f = (l + r + 1) / 2;
					pair<double, double> S = T[(s + 1 + f) % n];
					if (vec(Bc, mk(S.first - B.first, S.second - B.second)) > 0){
						r = f - 1;
					}
					else{
						l = f;
					}
				}
			}
			df = rec(T[(s + 1 + l) % n], mk(T[(s + 1 + l + 1) % n].first - T[(s + 1 + l) % n].first, T[(s + 1 + l + 1) % n].second - T[(s + 1 + l) % n].second), B, Bc);
			Res -= vec(df, B) + vec(T[(s + 1 + l) % n], df) + R[s + 1 + l] - R[s + 1];
		}
		
		printf("%0.10f ", Res / 2.0);
	}
}