#include "testlib.h"
#include <vector>
#include <set>
#include <cassert>

using namespace std;

const int max_number = 1000;
const int max_count = 1e6;

int main()
{
	registerValidation();
	int n = inf.readInt(1, max_number, "n");
    inf.readEoln();

    if (n == 1)
    {
        inf.readInt(0, 1);
        inf.readEoln();
        inf.readEof();
        return 0;
    }
    
	set <pair <int, int> > was;
	for (int i = 1; i <= n; i++)
	{
		int m = inf.readInt(1, n, "Too much power of vertex");
		inf.readSpace();
		for (int j = 0; j < m; j++)
		{
			int v = inf.readInt(1, n, "v");
			if (j < m - 1)
			{
				inf.readSpace(); 
			}
			ensuref(i != v, "Graph can't contain loops");
			if (v > i)
			{
                ensuref(was.count(make_pair(i, v)) == 0, "Graph can't contain multiple edges between a pair of vertices");
			}
			was.insert(make_pair(i, v));
			was.insert(make_pair(v, i));
		}
		inf.readEoln();
	}
	/*for (auto it = was.begin(); it != was.end(); it++)
	{
		assert(was.count(make_pair((*it).second, (*it).first)));
	}*/
	inf.readEof();
	return 0;
}