#include <bits/stdc++.h>

#ifndef LOCAL
#define cerr dolor_sit_amet
#endif

#define mp make_pair
#define sz(x) ((int)((x).size()))
#define X first
#define Y second

using namespace std;
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair < int , int > ipair;
typedef pair < ll , ll > lpair;
const int IINF = 0x3f3f3f3f;
const ll LINF = 0x3f3f3f3f3f3f3f3fll;
const double DINF = numeric_limits<double>::infinity();
const ll MOD = 1000000007;
const double EPS = 1e-9;
const int DX[] = { 1,  0, -1,  0,  1, -1,  1, -1};
const int DY[] = { 0,  1,  0, -1,  1, -1, -1,  1};

// ========================================================================= //

const int N = 1 << 18;

int n, m;
vector < string > s;
vector < int > p1[N], p0[N];
vector < pair < ipair , int > > qs[N];
string ans[N];

int tsum[N*2 - 1];

void tadd(int p, int v)
{
	tsum[p += N - 1] += v;
	while (p)
		tsum[(--p) /= 2] += v;
}

void tgo(int l, int r, string & ans, int c = 0, int cl = 0, int cr = N - 1)
{
	if (r <= 0 || l >= tsum[c] || tsum[c] == 0)
		return;
	if (cl == cr)
	{
		l = max(l, 0);
		r = min(r, tsum[c]);
		ans += s[cl].substr(l, r - l);
		return;
	}
	tgo(l, r, ans, c*2+1, cl, (cl+cr)/2);
	tgo(l - tsum[c*2+1], r - tsum[c*2+1], ans, c*2+2, (cl+cr)/2 + 1, cr);
}

int main()
{
#ifndef LOCAL
	freopen("stringsqueries.in", "r", stdin);
	freopen("stringsqueries.out", "w", stdout);
#endif
    ios::sync_with_stdio(false);

	cin >> n >> m;
	int qc1 = 0, qc2 = 0;
	while (m--)
	{
		int t;
		cin >> t;
		if (t == 1)
		{
			int l, r;
			string w;
			cin >> l >> r >> w;
			--l;
			s.push_back(w);
			p1[l].push_back(qc1);
			p0[r].push_back(qc1);
			++qc1;
		} else {
			int i, l, r;
			cin >> i >> l >> r;
			--i;
			--l;
			qs[i].emplace_back(ipair(l, r), qc2);
            ans[qc2].reserve(r - l + 1);
			++qc2;
		}
	}

	for (int i = 0; i < n; ++i)
	{
		for (int x : p1[i]) tadd(x, sz(s[x]));
		for (int x : p0[i]) tadd(x, -sz(s[x]));
		for (auto t : qs[i]) tgo(t.X.X, t.X.Y, ans[t.Y]);
	}

	for (int i = 0; i < qc2; ++i)
		cout << ans[i] << "\n";

    return 0;
}
