#include "bits/stdc++.h"
#define puba push_back
#define ff first
#define ss second
#define bend(_x) begin(_x), end(_x)
#define szof(_x) ((int) (_x).size())
#define TASK_NAME "squares"

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 7;
const double PI = atan2(0, -1);
const int MAXV = 1e6;

int n, m;

int main() {
    freopen(TASK_NAME ".in", "r", stdin);
    freopen(TASK_NAME ".out", "w", stdout);

    scanf("%d%d", &n, &m);

    ll ans = 0;
    for (int i = 1; i <= MAXV; ++i) {
        ans += (ll) (n / i) * (m / i);
    }

    int last = MAXV + 1;

    for (int i = 1; i <= 1000; ++i) {
        for (int j = 1; j <= 1000; ++j) {
            // n / k == i; n: i * k .. (i * k + k - 1); 
            int lg = 0, rg = 1e9;
            int l = -1, r = 1e9;
            while (r - l > 1) {
                int mid = (r + l) / 2;
                if ((ll) mid * i + mid - 1 < n) {
                    l = mid;
                } else {
                    r = mid;
                }
            }
            lg = max(lg, r);
            rg = min(rg, n / i);

            l = -1, r = 1e9;
            while (r - l > 1) {
                int mid = (r + l) / 2;
                if ((ll) mid * j + mid - 1 < m) {
                    l = mid;
                } else {
                    r = mid;
                }
            }
            lg = max(lg, r);
            rg = min(rg, m / j);

            lg = max(lg, last);

            if (lg <= rg) {
                ans += (ll) (rg - lg + 1) * i * j;
            }
        }
    }

    cout << ans << "\n";

    #ifdef LOCAL
        cerr << "time: " << clock() << endl;
    #endif
    return 0;
}